"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CurationEntry(ProtocolElement):
    """
    A curation for a known variant contains the current curation state and
    the curation history. Must be unique by `curation.phenotype` and
    `curation.inheritanceMode`.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "curation",
        "date",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import cva as cva_1_5_3

        return {
            "comments": cva_1_5_3.Comment,
            "curation": cva_1_5_3.Curation,
            "history": cva_1_5_3.CurationHistoryEntry,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.Comment": cva_1_5_3.Comment,
            "org.gel.models.cva.avro.Curation": cva_1_5_3.Curation,
            "org.gel.models.cva.avro.CurationHistoryEntry": cva_1_5_3.CurationHistoryEntry,
            "org.gel.models.cva.avro.CurationEntry": cva_1_5_3.CurationEntry,
        }

    __slots__ = [
        "curation",
        "date",
        "comments",
        "history",
    ]

    def __init__(
        self,
        curation,
        date,
        comments=list,
        history=list,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.CurationEntry model.

        :param curation:
            The current curation state
        :type curation: Curation
        :param date:
            Date in format yyyyMMddhhmm
        :type date: str
        :param comments:
            Comments on the curation event
        :type comments: list[Comment]
        :param history:
            The curation history
        :type history: list[CurationHistoryEntry]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
